import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Set of Buttons which serve as another means of selecting Objects.
 * Clicking on a Button will set the Field.obj to its respective Object type.
 * 
 * @author Mr. Hedgeapple 
 * @version 1.0
 */
public class Button extends Actor
{
    int type;
    /**
     * Basic constructor for Button.
     */
    public Button(int buttonType)
    {
        type = buttonType;
    }

    /**
     * Act - do whatever the Button wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        setButton();
        if (Greenfoot.mouseClicked(this))
            Field.obj = type;
    }    
    String names[] = 
        {"WALL", "WATER", "STONE", "FIRE", "CLONE", "LAVA", "METAL", "VINE", "GLASS", "POWDR", "SPARK"};
    boolean black[] = {true, true, true, true, false, true, false, true, false, true, true};
    int r[] = {125, 0,   100, 255, 100, 255, 50, 0,   0, 242, 255};
    int g[] = {125, 0,   100, 0,   15,  170,  50, 255, 0, 227, 240};
    int b[] = {125, 255, 100, 0,   15,  15,  50, 0,   0, 118, 30};

    /**
     * Constructs the image of the Button based on constructor int type.
     */
    private void setButton()
    {
        if (black[type])
            setImage(new GreenfootImage(" "+names[type]+" ", 30, Color.BLACK, new Color(r[type], g[type], b[type])));
        else
            setImage(new GreenfootImage(" "+names[type]+" ", 30, Color.WHITE, new Color(r[type], g[type], b[type])));
        GreenfootImage img = getImage();
        if (Field.obj == type)
            img.setColor(Color.WHITE);
        else
            img.setColor(Color.BLACK);
        img.drawRect(0, 0, img.getWidth()-1, img.getHeight()-1);
    }
}
