import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Area where all interactions take place.
 * 
 * @author Mr. Hedgeapple 
 * @version 3.0
 */
public class Field extends World
{
    //Changes scale of Field and all classes. Compatible with sizes of 10, 5, and 1.
    //Simulation runs best at size 10.
    public static int size = 10;
    public static int getSize()
    {
        return size;
    }
    
    //Current selected Object type.
    public static int obj;
    public static int getObj()
    {
        return obj;
    }
    
    /**
     * Constructor for objects of class Field.
     * 
     */
    public Field()
    {    
        super(1000/size, 600/size, size);
        
        prepare();
    }
    
    /**
     * Prepares UI classes.
     */
    private void prepare()
    {
        ObjectCount objectcount = new ObjectCount();
        addObject(objectcount, 50/size, 10/size);
        
        HeatDisplay heatdisplay = new HeatDisplay();
        addObject(heatdisplay, 50/size, 30/size);
        
        Cursor cursor = new Cursor();
        addObject(cursor, 450/size, 300/size);
        
        Border border = new Border();
        addObject(border, 900/size, 300/size);
        
        PauseButton pausebutton = new PauseButton();
        addObject(pausebutton, 950/size, 570/size);
        
        ClearButton clearbutton = new ClearButton();
        addObject(clearbutton, 950/size, 530/size);
        
        for (int i = 0; i < 11; i++)
        {
            addObject(new Button(i), 950/size, (20 + (30*i))/size);
        }
    }
    
    /**
     * Act - do whatever the Field wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act()
    {
        setObj();
        placeObject();
    }
    
    /**
     * Sets the current Object using the keyboard.
     */
    public void setObj()
    {
        if (Greenfoot.isKeyDown("1"))
            obj = 0;
        if (Greenfoot.isKeyDown("2"))
            obj = 1;
        if (Greenfoot.isKeyDown("3"))
            obj = 2;
        if (Greenfoot.isKeyDown("4"))
            obj = 3;
        if (Greenfoot.isKeyDown("5"))
            obj = 4;
        if (Greenfoot.isKeyDown("6"))
            obj = 5;
        if (Greenfoot.isKeyDown("7"))
            obj = 6;
        if (Greenfoot.isKeyDown("8"))
            obj = 7;
        if (Greenfoot.isKeyDown("9"))
            obj = 8;
        if (Greenfoot.isKeyDown("0"))
            obj = 9;
    }
    
    /**
     * Places the currently selected Object in the Field.
     */
    public void placeObject()
    {
        MouseInfo mouse = Greenfoot.getMouseInfo();
        if (Greenfoot.isKeyDown("space") && mouse != null && mouse.getX() < getWidth()-(100/size))
            addObject(new Objects(obj), mouse.getX(), mouse.getY());
    }
}
