import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
/**
 * Displays the heat value of any Objects indicated by the mouse.
 * 
 * @author Mr. Hedgeapple
 * @version 1.0
 */
public class HeatDisplay extends Actor
{
    int heat = 0;
    public HeatDisplay()
    {
        update();
    }

    /**
     * Act - do whatever the HeatDisplay wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        detect();
    }    

    /**
     * Updates the image of the HeatDisplay.
     */
    private void update()
    {
        setImage(new GreenfootImage(heat + " C", 20, Color.GREEN, Color.BLACK));
    }

    /**
     * Detects the Object indicated by the mouse and gets its heat value.
     */
    private void detect()
    {
        MouseInfo mouse = Greenfoot.getMouseInfo();
        if (mouse != null)
        {
            if (mouse.getActor() != null && mouse.getActor().getClass() == Objects.class)
            {
                Actor object = mouse.getActor();
                heat = (int)((Objects)(object)).getHeat();
                update();
            }
        }
    }
    
    /**
     * Finds the total amount of heat in all Objects in the Field.
     */
    private void detect2()
    {
        World myWorld = getWorld();
        if (!myWorld.getObjects(Objects.class).isEmpty())
        {
            List o = myWorld.getObjects(Objects.class);
            heat = 0;
            for (int i = 0; i < o.size(); i++)
            {
                heat += ((Objects)(o.get(i))).getHeat();
            }
            update();
        }
    }
}
