import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
/**
 * Tracks the number of Objects currently in the Field.
 * 
 * @author Mr. Hedgeapple 
 * @version 2.0
 */
public class ObjectCount extends Actor
{
    int number;
    /**
     * Basic constructor for ObjectCount.
     */
    public ObjectCount()
    {
        setImage(new GreenfootImage("Objects : 0", 20, Color.GREEN, Color.BLACK));
    }
    
    /**
     * Act - do whatever the ObjectCount wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        update();
    }    
    
    /**
     * Tracks and displays the number of Objects in the Field.
     */
    public void update()
    {
        World myWorld = getWorld();
        if (!myWorld.getObjects(Objects.class).isEmpty())
        {
            List obj = myWorld.getObjects(Objects.class);
            number = obj.size();
        } else
            number = 0;
        setImage(new GreenfootImage(" Objects : " + number, 20, Color.GREEN, Color.BLACK));
    }
}
